#ifndef CHARSETMAP_H
#define CHARSETMAP_H

#include <string>
using namespace std;

#include "Utility.h"

#define UNDEF_CHAR 0xFFFF

typedef unsigned short Word;
typedef unsigned char Byte;

const int __ULE_CHARSET_PAGE_SIZE = 256;

// Class CharSetMap:
// stores mapping for UCS-2 charset
class CharSetMap {
	int numOfChars;
	Word* CodePages [__ULE_CHARSET_PAGE_SIZE];
public:
	CharSetMap ();	// constructor 
	CharSetMap (const CharSetMap & );  // copy constructor
	~CharSetMap ();	// destructor

	int GetTotalNumOfChars ();
	unsigned short GetIndex (wchar_t wc);
	int Insert(wchar_t wc);
	void Clear ();
};

#endif
