
#include "Normalization.h"
#include "ConfigManager.h"
#include "Normalizer.h"


Normalization::Normalization()
{
	initialized = false;
	config = new ConfigManager;
	Compose = new Normalizer;
	Decompose = new Normalizer;
	KDecompose = new Normalizer;

	
}

Normalization::~Normalization()
{
	Clear();

}

void Normalization::Clear() 
{
	config->Clear();
	Compose->Clear();
	Decompose->Clear();
	KDecompose->Clear();
	
	delete Compose;
	delete Decompose;
	delete KDecompose;
	Compose = NULL;
	Decompose = NULL;
	KDecompose = NULL;

	
}


bool Normalization::Initialize()
{
	
	if (!config->Initialize())
		return false;

	if (!Compose->LoadNormRules(config->NFCfilepath))
		return false;
	if(!Decompose->LoadNormRules(config->NFDfilepath))
		return false;
	if(!KDecompose->LoadNormRules(config->NFKDfilepath))
		return false;

	initialized = true; 
	return true;
}
bool Normalization::Normalize(wstring source,NormMode mode,wstring &result)
{

	if(!initialized)
		return false;
	if(mode==NFC)
		result = Compose->NormalizeString(source);
	else if(mode==NFD)
		result = Decompose->NormalizeString(source);
	else if(mode==NFKD)
		result = KDecompose->NormalizeString(source);
	else
		return false;


	return true;

	
}
